#include "svc_rpc.h"
#include "rpc_node.h"
#include "tuya_ipc_stream_storage.h"
#include "tuya_ipc_log_demo.h"
#include "tuya_ipc_rpc_auto_api.h"

void rpc_ipc_server_tuya_ipc_ss_uninit(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    tuya_ipc_ss_uninit();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_set_write_mode(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int write_mode;

    jrpc_read_int(request,JRPC_PARAMS,"write_mode",&write_mode);

    PR_INFO("start to set:%d \n",write_mode);
    ret = tuya_ipc_ss_set_write_mode(write_mode);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_get_write_mode(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int write_mode = 0;

    write_mode = tuya_ipc_ss_get_write_mode();

    PR_INFO("get ss write mode is:%d \n",write_mode);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", write_mode);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_start_event(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_ss_start_event(0);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_stop_event(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_ss_stop_event(0);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_start_event_by_type(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int type = 0;

    jrpc_read_int(request, JRPC_PARAMS, "type", &type);
    ret = tuya_ipc_ss_start_event_by_type(0, type);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_stop_event_by_type(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int type = 0;

    jrpc_read_int(request, JRPC_PARAMS, "type", &type);
    ret = tuya_ipc_ss_stop_event_by_type(0, type);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_set_pre_record_time(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int pre_record_second = 0;

    jrpc_read_int(request, JRPC_PARAMS, "pre_record_second", &pre_record_second);

    ret = tuya_ipc_ss_set_pre_record_time(pre_record_second);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_set_max_event_duration(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    int max_event_duration = 0;

    jrpc_read_int(request, JRPC_PARAMS, "max_event_duration", &max_event_duration);

    ret = tuya_ipc_ss_set_max_event_duration(max_event_duration);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_delete_oldest_event(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_ss_delete_oldest_event();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_delete_all_files(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    tuya_ipc_ss_delete_all_files();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_ss_get_status(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_ss_get_status();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void rpc_ipc_server_tuya_ipc_pb_query_by_month(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T query_year;
    UINT_T query_month;
    UINT_T p_return_days;

    jrpc_read_int(request,JRPC_PARAMS,"query_year",&query_year);
    jrpc_read_int(request,JRPC_PARAMS,"query_month",&query_month);

    ret = tuya_ipc_pb_query_by_month(0, query_year, query_month, &p_return_days);

    PR_INFO("query by month res is:%d \n",p_return_days);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);
    jrpc_write_int(reply, JRPC_RESULT, "days", p_return_days);

}

void rpc_ipc_server_tuya_ipc_pb_query_by_day(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T pbIdx;
    UINT_T year;
    UINT_T month;
    UINT_T day;
    SS_QUERY_DAY_TS_ARR_T *pTsArr;

    jrpc_read_int(request,JRPC_PARAMS,"pb_idx",&pbIdx);
    jrpc_read_int(request,JRPC_PARAMS,"year",&year);
    jrpc_read_int(request,JRPC_PARAMS,"month",&month);
    jrpc_read_int(request,JRPC_PARAMS,"day",&day);
    
    ret = tuya_ipc_pb_query_by_day(pbIdx, 0, year, month, day, &pTsArr);

    PR_INFO("get today video cnt is:%d \n",pTsArr->file_count);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);
    jrpc_write_int(reply, JRPC_RESULT, "file_count", pTsArr->file_count);

    ty_cJSON* arr = ty_cJSON_CreateArray();
    int i = 0;
    for(;i < pTsArr->file_count;i++){
        ty_cJSON* item = ty_cJSON_CreateObject();
        ty_cJSON_AddItemToObject(item, "type", ty_cJSON_CreateNumber(pTsArr->file_arr[i].type));
        ty_cJSON_AddItemToObject(item, "start_timestamp", ty_cJSON_CreateNumber(pTsArr->file_arr[i].start_timestamp));
        ty_cJSON_AddItemToObject(item, "end_timestamp", ty_cJSON_CreateNumber(pTsArr->file_arr[i].end_timestamp));
        ty_cJSON_AddItemToArray(arr, item);
    }
    char* arr_str = ty_cJSON_PrintUnformatted(arr);
    jrpc_write_string(reply, JRPC_RESULT, "file_arr", arr_str);
    ty_cJSON_FreeBuffer(arr_str);
    ty_cJSON_Delete(arr);


    return;
}

#if 0
void rpc_ipc_server_tuya_ipc_ss_pb_start(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T pb_idx;

    jrpc_read_int(request,JRPC_PARAMS,"pb_idx",&pb_idx);
    
    ret = tuya_ipc_ss_pb_start(pb_idx, __TUYA_APP_ss_pb_event_cb, __TUYA_APP_ss_pb_get_video_cb, __TUYA_APP_ss_pb_get_audio_cb);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

}


void rpc_ipc_server_tuya_ipc_ss_pb_set_status(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T pb_idx;
    UINT_T new_status;

    jrpc_read_int(request,JRPC_PARAMS,"pb_idx",&pb_idx);
    jrpc_read_int(request,JRPC_PARAMS,"new_status",&new_status);
    
    ret = tuya_ipc_ss_pb_set_status(pb_idx, new_status);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

}

void rpc_ipc_server_tuya_ipc_ss_pb_stop(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T pb_idx;

    jrpc_read_int(request,JRPC_PARAMS,"pb_idx",&pb_idx);
    
    ret = tuya_ipc_ss_pb_stop(pb_idx);


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

}

void rpc_ipc_server_tuya_ipc_ss_pb_stop_all(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;
    UINT_T pb_idx;

    jrpc_read_int(request,JRPC_PARAMS,"pb_idx",&pb_idx);
    
    ret = tuya_ipc_ss_pb_stop_all();


    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

}
#endif

void tuya_ipc_rpc_server_declare_sd()
{
    //tuya_ipc_rpc_server_declare("tuya_ipc_ss_init", rpc_ipc_server_tuya_ipc_ss_init, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_uninit", rpc_ipc_server_tuya_ipc_ss_uninit, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_set_write_mode", rpc_ipc_server_tuya_ipc_ss_set_write_mode, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_get_write_mode", rpc_ipc_server_tuya_ipc_ss_get_write_mode, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_start_event", rpc_ipc_server_tuya_ipc_ss_start_event, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_stop_event", rpc_ipc_server_tuya_ipc_ss_stop_event, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_start_event_by_type", rpc_ipc_server_tuya_ipc_ss_start_event_by_type, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_stop_event_by_type", rpc_ipc_server_tuya_ipc_ss_stop_event_by_type, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_set_pre_record_time", rpc_ipc_server_tuya_ipc_ss_set_pre_record_time, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_set_max_event_duration", rpc_ipc_server_tuya_ipc_ss_set_max_event_duration, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_delete_oldest_event", rpc_ipc_server_tuya_ipc_ss_delete_oldest_event, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_delete_all_files", rpc_ipc_server_tuya_ipc_ss_delete_all_files, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_ss_get_status", rpc_ipc_server_tuya_ipc_ss_get_status, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_pb_query_by_month", rpc_ipc_server_tuya_ipc_pb_query_by_month, NULL);
    tuya_ipc_rpc_server_declare("tuya_ipc_pb_query_by_day", rpc_ipc_server_tuya_ipc_pb_query_by_day, NULL);
    //tuya_ipc_rpc_server_declare("tuya_ipc_ss_pb_start", rpc_ipc_server_tuya_ipc_ss_pb_start, NULL);
    //tuya_ipc_rpc_server_declare("tuya_ipc_ss_pb_set_status", rpc_ipc_server_tuya_ipc_ss_pb_set_status, NULL);
    //tuya_ipc_rpc_server_declare("tuya_ipc_ss_pb_stop", rpc_ipc_server_tuya_ipc_ss_pb_stop, NULL);
    //tuya_ipc_rpc_server_declare("tuya_ipc_ss_pb_stop_all", rpc_ipc_server_tuya_ipc_ss_pb_stop_all, NULL);

    return;
}
