#include "svc_rpc.h"
#include "tuya_error_code.h"
#include "tuya_ipc_log_demo.h"
#include "tuya_ipc_video_msg.h"
#include "tuya_ipc_rpc_auto_api.h"

STATIC VOID rpc_ipc_server_tuya_ipc_leave_video_msg(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    OPERATE_RET ret = OPRT_OK;
    UCHAR_T *data = NULL;
    USHORT_T size = 0;
    INT_T data_len;
    
    if (OPRT_OK != (ret = jrpc_read_binary(request, JRPC_PARAMS, "extra_data", &data, &size))) {
       PR_ERR("read extra_data failed\n");
       goto finish;
    }

    if (OPRT_OK != (ret = jrpc_read_int(request, JRPC_PARAMS, "data_len", &data_len))) {
       PR_ERR("read data_len failed\n");
       goto finish;
    }

    ret = tuya_ipc_leave_video_msg(data, data_len);

finish:
    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);
}


STATIC VOID rpc_ipc_server_tuya_ipc_md_video_msg(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    OPERATE_RET ret = OPRT_OK;
    UCHAR_T *data = NULL;
    USHORT_T size = 0;
    INT_T data_len;
    
    if (OPRT_OK != (ret = jrpc_read_binary(request, JRPC_PARAMS, "extra_data", &data, &size))) {
       PR_ERR("read extra_data failed\n");
       goto finish;
    }

    if (OPRT_OK != (ret = jrpc_read_int(request, JRPC_PARAMS, "data_len", &data_len))) {
       PR_ERR("read data_len failed\n");
       goto finish;
    }

    ret = tuya_ipc_md_video_msg(data, data_len);

finish:
    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);
}


void tuya_ipc_rpc_server_declare_video_msg()
{
    tuya_ipc_rpc_server_declare( "tuya_ipc_leave_video_msg", rpc_ipc_server_tuya_ipc_leave_video_msg, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_md_video_msg", rpc_ipc_server_tuya_ipc_md_video_msg, NULL);
}

