#include "tuya_ipc_rpc_auto_api.h"
#include "tuya_ipc_log_demo.h"

typedef struct {
    rpc_method_cb cb;
    char name[0];
} TUYA_IPC_RPC_METHOD_T;

STATIC TUYA_IPC_RPC_METHOD_T* g_method_table[1024] = {0};

int tuya_ipc_rpc_server_declare(char *name, rpc_method_cb cb, void *arg)
{
    int i = 0;
    for(i = 0; i < sizeof(g_method_table) / sizeof(g_method_table[0]); i++){
        if (g_method_table[i] == NULL){
            TUYA_IPC_RPC_METHOD_T* method = (TUYA_IPC_RPC_METHOD_T*)malloc(sizeof(TUYA_IPC_RPC_METHOD_T) + strlen(name) + 1);
            if (NULL == method){
                PR_ERR("malloc failed\n");
                return OPRT_MALLOC_FAILED;
            }

            strcpy(method->name, name);
            method->cb = cb;
            g_method_table[i] = method;
            break;
        }
    }

    return 0;
}

int tuya_ipc_rpc_server_call(char* name, jrpc_msg_t *request, void* arg, jrpc_msg_t* reply)
{
    int i = 0;
    for(i = 0; i < sizeof(g_method_table) / sizeof(g_method_table[0]); i++){
        if (g_method_table[i] != NULL){
            TUYA_IPC_RPC_METHOD_T* method = g_method_table[i];
            if (strcmp(name, method->name) == 0){
                method->cb(request, arg, reply);
                return 0;
            }
        }
    }

    PR_ERR("method(%s) not found\n", name);
    return -1;
}